diff --git a/MDL67249-model-evaluate-adhoc-task.patch b/MDL67249-model-evaluate-adhoc-task.patch
index ca2db414556..e69de29bb2d 100644
--- a/MDL67249-model-evaluate-adhoc-task.patch
+++ b/MDL67249-model-evaluate-adhoc-task.patch
@@ -1,93 +0,0 @@
-diff --git a/admin/tool/analytics/classes/output/models_list.php b/admin/tool/analytics/classes/output/models_list.php
-index be1cb664949..9ebe257bb75 100644
---- a/admin/tool/analytics/classes/output/models_list.php
-+++ b/admin/tool/analytics/classes/output/models_list.php
-@@ -95,7 +95,10 @@ class models_list implements \renderable, \templatable {
-             // Default applied if no config found.
-             $onlycli = 1;
-         }
--
-+        
-+        //As evaluation is running in the background as an adhoc task, the onlycli is no longer relevant 
-+        $onlycli = 0;
-+        
-         // Evaluation options.
-         $timesplittingsforevaluation = \core_analytics\manager::get_time_splitting_methods_for_evaluation(true);
- 
-diff --git a/admin/tool/analytics/model.php b/admin/tool/analytics/model.php
-index ab9f304143a..ba7d5b35765 100644
---- a/admin/tool/analytics/model.php
-+++ b/admin/tool/analytics/model.php
-@@ -24,6 +24,7 @@
- 
- require_once(__DIR__ . '/../../../config.php');
- require_once($CFG->libdir . '/filelib.php');
-+use tool_analytics\task\adhoc_models;
- 
- $id = required_param('id', PARAM_INT);
- $action = required_param('action', PARAM_ALPHANUMEXT);
-@@ -189,40 +190,39 @@ switch ($action) {
-             throw new moodle_exception('errornostaticevaluate', 'tool_analytics');
-         }
- 
--        if ($onlycli) {
--            throw new moodle_exception('erroronlycli', 'tool_analytics');
--        }
--
--        // Web interface is used by people who can not use CLI nor code stuff, always use
--        // cached stuff as they will change the model through the web interface as well
--        // which invalidates the previously analysed stuff.
--        $options = ['reuseprevanalysed' => true];
- 
-         $mode = optional_param('mode', false, PARAM_ALPHANUM);
-         if ($mode == 'trainedmodel') {
--            $options['mode'] = 'trainedmodel';
-+            $mode = 'trainedmodel';
-         } else {
--
--            // All is the default in core_analytics\model::evaluate() as well.
--            $timesplitting = optional_param('timesplitting', 'all', PARAM_ALPHANUMEXT);
--            if ($timesplitting === 'current') {
--                $options['timesplitting'] = \core_analytics\manager::get_time_splitting($model->get_model_obj()->timesplitting);
--            } else if ($timesplitting !== 'all') {
--                $options['timesplitting'] = \core_analytics\manager::get_time_splitting(
--                    \tool_analytics\output\helper::option_to_class($timesplitting)
--                );
--            }
-+            $mode == 'configuration';            
-         }
- 
--        $results = $model->evaluate($options);
-+        $adhocoptions = array(
-+            'timesplitting' => required_param('timesplitting', PARAM_ALPHANUMEXT),
-+            'reuseprevanalysed' => true,
-+            'mode' => $mode,
-+            'non-interactive' => false,
-+        );
-+
-+        $modeltoevaluate[] = array('modelid' => $id , 'options' => $adhocoptions);
-+    
-+        // create the instance
-+        $adhocevaluate = new adhoc_models();
-+
-+        // add custom data
-+        $adhocevaluate->set_custom_data($modeltoevaluate);
-+
-+        // queue it
-+        \core\task\manager::queue_adhoc_task($adhocevaluate);
-+
-+        $results = "Evaluation added to adhoc task, <a href='/admin/tasklogs.php' target='_blank'>click here</a> to learn more. <a href='".$returnurl."'>Click here</a> to go back.";
- 
--        // We reset the theme and the output as some indicators may be using external functions
--        // which reset $PAGE.
--        \tool_analytics\output\helper::reset_page();
-         echo $OUTPUT->header();
-+        echo $results;
-+        echo $OUTPUT->footer();
- 
--        $renderer = $PAGE->get_renderer('tool_analytics');
--        echo $renderer->render_evaluate_results($results, $model->get_analyser()->get_logs());
-+       
-         break;
- 
-     case 'scheduledanalysis':